OpenVDB: Ray< RealT > Class Template Reference

OpenVDB 8.0.0

Classes | Public Types | Public Member Functions | List of all members
Ray< RealT > Class Template Reference

`#include <Ray.h>`

## Classes
struct | TimeSpan

## Public Types
using | RealType = RealT
using | Vec3Type = Vec3< RealT >
using | Vec3T = Vec3Type

## Public Member Functions
| Ray (const Vec3Type &eye=Vec3Type(0, 0, 0), const Vec3Type &direction=Vec3Type(1, 0, 0), RealT t0=math::Delta< RealT >::value(), RealT t1=std::numeric_limits< RealT >::max())
void | setEye (const Vec3Type &eye)
void | setDir (const Vec3Type &dir)
void | setMinTime (RealT t0)
void | setMaxTime (RealT t1)
void | setTimes (RealT t0=math::Delta< RealT >::value(), RealT t1=std::numeric_limits< RealT >::max())
void | scaleTimes (RealT scale)
void | reset (const Vec3Type &eye, const Vec3Type &direction, RealT t0=math::Delta< RealT >::value(), RealT t1=std::numeric_limits< RealT >::max())
const Vec3T & | eye () const
const Vec3T & | dir () const
const Vec3T & | invDir () const
RealT | t0 () const
RealT | t1 () const
Vec3R | operator() (RealT time) const
| Return the position along the ray at the specified time. More...
Vec3R | start () const
| Return the starting point of the ray. More...
Vec3R | end () const
| Return the endpoint of the ray. More...
Vec3R | mid () const
| Return the midpoint of the ray. More...
bool | valid (RealT eps=math::Delta< float >::value()) const
| Return `true` if t1 is larger than t0 by at least eps. More...
bool | test (RealT time) const
| Return `true` if time is within t0 and t1, both inclusive. More...
template<typename MapType >
Ray | applyMap (const MapType &map) const
| Return a new Ray that is transformed with the specified map. More...
template<typename MapType >
Ray | applyInverseMap (const MapType &map) const
| Return a new Ray that is transformed with the inverse of the specified map. More...
template<typename GridType >
Ray | indexToWorld (const GridType &grid) const
| Return a new ray in world space, assuming the existing ray is represented in the index space of the specified grid. More...
template<typename GridType >
Ray | worldToIndex (const GridType &grid) const
| Return a new ray in the index space of the specified grid, assuming the existing ray is represented in world space. More...
bool | intersects (const Vec3T &center, RealT radius, RealT &t0, RealT &t1) const
| Return true if this ray intersects the specified sphere. More...
bool | intersects (const Vec3T &center, RealT radius) const
| Return true if this ray intersects the specified sphere. More...
bool | clip (const Vec3T &center, RealT radius)
| Return true if this ray intersects the specified sphere. More...
template<typename BBoxT >
bool | intersects (const BBoxT &bbox, RealT &t0, RealT &t1) const
| Return true if the Ray intersects the specified axisaligned bounding box. More...
template<typename BBoxT >
bool | intersects (const BBoxT &bbox) const
| Return true if this ray intersects the specified bounding box. More...
template<typename BBoxT >
bool | clip (const BBoxT &bbox)
| Return true if this ray intersects the specified bounding box. More...
bool | intersects (const Vec3T &normal, RealT distance, RealT &t) const
| Return true if the Ray intersects the plane specified by a normal and distance from the origin. More...
bool | intersects (const Vec3T &normal, const Vec3T &point, RealT &t) const
| Return true if the Ray intersects the plane specified by a normal and point. More...

## Member Typedef Documentation

## ◆ RealType

using RealType = RealT

## ◆ Vec3T

using Vec3T = Vec3Type

## ◆ Vec3Type

using Vec3Type = Vec3<RealT>

## Constructor & Destructor Documentation

## ◆ Ray()

Ray | ( | const Vec3Type & | eye = `Vec3Type(0,0,0)`,
|  | const Vec3Type & | direction = `Vec3Type(1,0,0)`,
|  | RealT | t0 = `math::Delta<RealT>::value()`,
|  | RealT | t1 = `std::numeric_limits<RealT>::max()`
| ) |  |
| inline

## Member Function Documentation

## ◆ applyInverseMap()

Ray applyInverseMap | ( | const MapType & | map | ) | const
| inline

Return a new Ray that is transformed with the inverse of the specified map.

Parameters

  map | the map from which to construct the new Ray by inverse mapping.

Warning
  Assumes a linear map and a normalized direction. The requirement that the direction is normalized follows from the transformation of t0 and t1 - and that fact that we want applyMap and applyInverseMap to be inverse operations.

## ◆ applyMap()

Ray applyMap | ( | const MapType & | map | ) | const
| inline

Return a new Ray that is transformed with the specified map.

Parameters

  map | the map from which to construct the new Ray.

Warning
  Assumes a linear map and a normalized direction. The requirement that the direction is normalized follows from the transformation of t0 and t1 - and that fact that we want applyMap and applyInverseMap to be inverse operations.

## ◆ clip() [1/2]

bool clip | ( | const BBoxT & | bbox | ) |
| inline

Return true if this ray intersects the specified bounding box.

Note
  For intersection this ray is clipped to the two intersection points.

Parameters

  bbox | Axis-aligned bounding box in the same space as this ray.

## ◆ clip() [2/2]

bool clip | ( | const Vec3T & | center,
|  | RealT | radius
| ) |  |
| inline

Return true if this ray intersects the specified sphere.

Note
  For intersection this ray is clipped to the two intersection points.

Parameters

  center | The center of the sphere in the same space as this ray.
  radius | The radius of the sphere in the same units as this ray.

## ◆ dir()

const Vec3T& dir | ( |  | ) | const
| inline

## ◆ end()

Vec3R end | ( |  | ) | const
| inline

Return the endpoint of the ray.

## ◆ eye()

const Vec3T& eye | ( |  | ) | const
| inline

## ◆ indexToWorld()

Ray indexToWorld | ( | const GridType & | grid | ) | const
| inline

Return a new ray in world space, assuming the existing ray is represented in the index space of the specified grid.

## ◆ intersects() [1/6]

bool intersects | ( | const BBoxT & | bbox | ) | const
| inline

Return true if this ray intersects the specified bounding box.

Parameters

  bbox | Axis-aligned bounding box in the same space as this ray.

## ◆ intersects() [2/6]

bool intersects | ( | const BBoxT & | bbox,
|  | RealT & | t0,
|  | RealT & | t1
| ) |  | const
| inline

Return true if the Ray intersects the specified axisaligned bounding box.

Parameters

  bbox | Axis-aligned bounding box in the same space as the Ray.
  t0 | If an intersection is detected this is assigned the time for the first intersection point.
  t1 | If an intersection is detected this is assigned the time for the second intersection point.

## ◆ intersects() [3/6]

bool intersects | ( | const Vec3T & | center,
|  | RealT | radius
| ) |  | const
| inline

Return true if this ray intersects the specified sphere.

Parameters

  center | The center of the sphere in the same space as this ray.
  radius | The radius of the sphere in the same units as this ray.

## ◆ intersects() [4/6]

bool intersects | ( | const Vec3T & | center,
|  | RealT | radius,
|  | RealT & | t0,
|  | RealT & | t1
| ) |  | const
| inline

Return true if this ray intersects the specified sphere.

Parameters

  center | The center of the sphere in the same space as this ray.
  radius | The radius of the sphere in the same units as this ray.
  t0 | The first intersection point if an intersection exists.
  t1 | The second intersection point if an intersection exists.

Note
  If the return value is true, i.e. a hit, and t0 = this->t0() or t1 == this->t1() only one true intersection exist.

## ◆ intersects() [5/6]

bool intersects | ( | const Vec3T & | normal,
|  | const Vec3T & | point,
|  | RealT & | t
| ) |  | const
| inline

Return true if the Ray intersects the plane specified by a normal and point.

Parameters

  normal | Normal of the plane.
  point | Point in the plane.
  t | Time of intersection, if one exists.

## ◆ intersects() [6/6]

bool intersects | ( | const Vec3T & | normal,
|  | RealT | distance,
|  | RealT & | t
| ) |  | const
| inline

Return true if the Ray intersects the plane specified by a normal and distance from the origin.

Parameters

  normal | Normal of the plane.
  distance | Distance of the plane to the origin.
  t | Time of intersection, if one exists.

## ◆ invDir()

const Vec3T& invDir | ( |  | ) | const
| inline

## ◆ mid()

Vec3R mid | ( |  | ) | const
| inline

Return the midpoint of the ray.

## ◆ operator()()

Vec3R operator() | ( | RealT | time | ) | const
| inline

Return the position along the ray at the specified time.

## ◆ reset()

void reset | ( | const Vec3Type & | eye,
|  | const Vec3Type & | direction,
|  | RealT | t0 = `math::Delta<RealT>::value()`,
|  | RealT | t1 = `std::numeric_limits<RealT>::max()`
| ) |  |
| inline

## ◆ scaleTimes()

void scaleTimes | ( | RealT | scale | ) |
| inline

## ◆ setDir()

void setDir | ( | const Vec3Type & | dir | ) |
| inline

## ◆ setEye()

void setEye | ( | const Vec3Type & | eye | ) |
| inline

## ◆ setMaxTime()

void setMaxTime | ( | RealT | t1 | ) |
| inline

## ◆ setMinTime()

void setMinTime | ( | RealT | t0 | ) |
| inline

## ◆ setTimes()

void setTimes | ( | RealT | t0 = `math::Delta<RealT>::value()`,
|  | RealT | t1 = `std::numeric_limits<RealT>::max()`
| ) |  |
| inline

## ◆ start()

Vec3R start | ( |  | ) | const
| inline

Return the starting point of the ray.

## ◆ t0()

RealT t0 | ( |  | ) | const
| inline

## ◆ t1()

RealT t1 | ( |  | ) | const
| inline

## ◆ test()

bool test | ( | RealT | time | ) | const
| inline

Return `true` if time is within t0 and t1, both inclusive.

## ◆ valid()

bool valid | ( | RealT | eps = `math::Delta<float>::value()` | ) | const
| inline

Return `true` if t1 is larger than t0 by at least eps.

## ◆ worldToIndex()

Ray worldToIndex | ( | const GridType & | grid | ) | const
| inline

Return a new ray in the index space of the specified grid, assuming the existing ray is represented in world space.

The documentation for this class was generated from the following file:

- Ray.h